﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Bluetooth;
using Android.Provider;
using System.Collections.Generic;
using Java.Util;
using System.Runtime.Remoting.Messaging;
using Android.Database;
using Org.Json;
using Java.IO;
using System.IO;
using System.Text;
using Org.Apache.Http.Protocol;

namespace xm_Bluetooth
{
	[Activity (Label = "xm_Bluetooth", MainLauncher = true)]
	public class MainActivity : Activity
	{
		Button btnfile;
		Button btnprint;
		Button btncon;
		TextView labmsg;
		private BluetoothAdapter bluetoothAdapter;

		SimpleAdapter adapter;
		ListView lv;
		AlertDialog dialog;

		 BluetoothSocket socket;
		 BluetoothDevice device;
		UUID MY_UUID_SECURE = UUID.FromString("00001101-0000-1000-8000-00805F9B34FB");
		UUID MY_UUID_SECURE1 = UUID.FromString("fa87c0d0-afac-11de-8a39-0800200c9a66");
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);

			// Get our button from the layout resource,
			// and attach an event to it
			InitView ();
		}

		void InitView()
		{
			btnfile = FindViewById<Button> (Resource.Id.btnfile);
			btnprint = FindViewById<Button> (Resource.Id.btnPrint);
			btncon = FindViewById<Button> (Resource.Id.btncon);
			labmsg = FindViewById<TextView> (Resource.Id.labmsg);

			bluetoothAdapter = BluetoothAdapter.DefaultAdapter;

			if (null != bluetoothAdapter) {

				if (!bluetoothAdapter.IsEnabled) {
					Intent intent = new Intent (
						                BluetoothAdapter.ActionRequestEnable);
					intent.PutExtra (BluetoothAdapter.ExtraDiscoverableDuration,
						400);
					StartActivity (intent); // 或者ba.enable();
					// //同样的关闭WIFi为ba.disable();

				}

			} else {

				Toast.MakeText (this, GetString (Resource.String.noblue),
					ToastLength.Long).Show ();

			}

			btnfile.Click += new EventHandler (delegate {
			
				try
				{
					Toast.MakeText (this, GetString (Resource.String.nofilefun),
						ToastLength.Long).Show ();
					return;
				
					string path=Android.OS.Environment.ExternalStorageDirectory.ToString ();
				Java.IO.File file=new Java.IO.File(path);
				

				var intent = new Intent();
					intent.AddCategory(Intent.CategoryOpenable);
					intent.SetType ("*/*");

				
					intent.SetAction(Intent.ActionGetContent);//.ActionGetContent);
				StartActivityForResult(intent, 2);
				}
				catch(Exception ex)
				{

				}
				finally{

				}

			});

			btncon.Click += new EventHandler (delegate {
				if (socket != null && socket.IsConnected) {
					socket.Close ();
					btncon.Text = GetString (Resource.String.nocon);
					Toast.MakeText (this, GetString (Resource.String.nocon),
						ToastLength.Long).Show ();
					return;
				}
				AlertDialog.Builder builder = new AlertDialog.Builder (
					                              this);

				builder.SetTitle ("Device");
				builder.SetIcon (Resource.Drawable.Icon);
				View view = LayoutInflater.From (this).Inflate (
					            Resource.Layout.showblue, null);

				lv = view.FindViewById<ListView> (Resource.Id.listView1);
				Button btnscan = view.FindViewById<Button> (Resource.Id.btnScan);
				// 这段代码不知道放在哪里，
			
				List<BluetoothDevice> lstDevice = new List<BluetoothDevice> (bluetoothAdapter.BondedDevices);
				var datalist = new List<IDictionary<string, object>> ();
				for (int i = 0; i < lstDevice.Count; i++) {
					BluetoothDevice device = (BluetoothDevice)lstDevice [i];
					　
					var item = new JavaDictionary<string, object> ();　　
					item.Add ("name", device.Name);
					item.Add ("add", device.Address);　
					　
					datalist.Add (item);
				}
				adapter = new SimpleAdapter (this, datalist, Resource.Layout.list,
					new String[] { "name", "add" },
					new int[] { Resource.Id.listname, Resource.Id.listadd });
				lv.Adapter = adapter;				
				builder.SetView (view);
				dialog = builder.Create ();

				btnscan.Click += new EventHandler (delegate {
					lv.Adapter = null;
					Intent intent = new Intent (Settings.ActionBluetoothSettings);					
					intent.PutExtra (
						BluetoothAdapter.ExtraDiscoverableDuration, 400);
					StartActivity (intent); // 或者ba.enable();
					// //同样的关闭WIFi为ba.disable();

					List<BluetoothDevice> lstDevice2 = new List<BluetoothDevice> (bluetoothAdapter.BondedDevices);
					var datalist2 = new List<IDictionary<string, object>> ();
					for (int i = 0; i < lstDevice2.Count; i++) {
						BluetoothDevice device = (BluetoothDevice)lstDevice2 [i];
							　
						var item = new JavaDictionary<string, object> ();　　
						item.Add ("name", device.Name);
						item.Add ("add", device.Address);　
							　
						datalist.Add (item);
					}
					adapter = new SimpleAdapter (this, datalist2, Resource.Layout.list,
						new String[] { "name", "add" },
						new int[] { Resource.Id.listname, Resource.Id.listadd });
					lv.Adapter = adapter;
				});

				//	lv.ItemClick+=ListView_ItemClick();
				lv.ItemClick += new EventHandler<AdapterView.ItemClickEventArgs> (ListView_ItemClick);

				dialog.Show ();
			
			});

			btnprint.Click += new EventHandler (delegate {
				try {
				
					if (string.IsNullOrEmpty (labmsg.Text.Trim ())) {
						Toast.MakeText (this, "Input Data",
							ToastLength.Long).Show ();
						return;
					}
					if (socket!=null && socket.IsConnected) {
						Stream sw = socket.OutputStream;
						//StreamWriter sw = new StreamWriter (socket.OutputStream);
						byte[] data = Encoding.Default.GetBytes (labmsg.Text.Trim () + "\r\n\n");
						sw.Write (data, 0, data.Length);
						sw.Flush ();
						sw.Close ();
					}
					else
					{
						Toast.MakeText (this,GetString(Resource.String.nocon),
							ToastLength.Long).Show ();
					}
				} catch (Exception ex) {
					Toast.MakeText(this, "Error", ToastLength.Short).Show();
				} finally {
				}
			});

		}

		protected override  void OnActivityResult(int requestCode, Result  resultCode, Intent data) 
		{
				// TODO Auto-generated method stub
			switch (requestCode) {
			case 1: //打开蓝牙请求
				if(resultCode==Result.Ok) { //同意打开蓝牙

					} else {
						
					}
					break;
				default:
					break;
				}
			base.OnActivityResult(requestCode, resultCode, data);
			}


	
	

		void ListView_ItemClick(object sender, AdapterView.ItemClickEventArgs e)
		{
			try
			{
				View ls = e.Parent as View;
				string addr	=ls.FindViewById<TextView> (Resource.Id.listadd).Text;
				List<BluetoothDevice> lstDevice= new List<BluetoothDevice> (bluetoothAdapter.BondedDevices);

				for (int i = 0; i < lstDevice.Count; i++) 
				{ device= (BluetoothDevice) lstDevice[i];
					if(device.Address==addr)
					{

						socket = device.CreateRfcommSocketToServiceRecord (MY_UUID_SECURE);

						socket.Connect ();
						Toast.MakeText(this, GetString (Resource.String.iscon),
							ToastLength.Long).Show();
						btncon.Text=GetString (Resource.String.iscon);
						break;
					}

				}

			}
			catch(Exception ex) {
				Toast.MakeText(this, "Error", ToastLength.Short).Show();
			}
			finally{
				dialog.Dismiss ();
			


			}



		}
	

		protected override void OnPause()
		{
			base.OnPause ();
			if(socket!=null && socket.IsConnected)
			{
				socket.Close ();
			
			}
		}


	}

	public static  class JavaCast
	{
		public static  T Cast<T>(this Java.Lang.Object obj) where T : class
		{
			var propertyInfo = obj.GetType().GetProperty("Instance");
			return propertyInfo == null ? null : propertyInfo.GetValue(obj, null) as T;
		}
	}

}


